      PROGRAM optmain
      IMPLICIT NONE

C********************************************************************
! Main optimization program: 
! Calls IFFCO and feeds in the propoer objective function FEVAL
!
C******************************************************************
! Program created by Katie Kavanagh 9/16/02
! Last Modified: 12/16/02 added postprocessing
C***************************************************************** 
      INTEGER I, DIM, MAXIT(2), RESTART, MAXCUTS, flag,WRIT
      INTEGER OPTION(30)
      INTEGER NLAY, NCOL, NROW
C~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      EXTERNAL FEVAL, comminitIF, commexitIF
C~~~~~~~~~~~~~~~~~~~~~~~~
      PARAMETER(DIM = 12)
C !!!!! NROW, NLAY, NCOL must also be set in feval.f
      PARAMETER(NROW = 100)
      PARAMETER(NCOL = 100)
      PARAMETER(NLAY = 10)

C~~~~~~~~~~~~~~~~~~~~~~~~
      DOUBLE PRECISION U(DIM), L(DIM), V(DIM)
      DOUBLE PRECISION FMIN, TERMTOL, FSCALE,MINH,MAXH,FV
      REAL*8 HEAD(NROW,NCOL,NLAY)
C Set parameters for IFFCO

C Set upper and lower box constraints

C Set constraints

C constraint on locations:
      DO 10 , I=1,8
      U(I) = 990.00
      L(I) = 10.00
 10   CONTINUE

C Constraint on pumping rates
      DO 20 , I=9,12
      U(I) = 0.0064
      L(I) = -0.0064
 20   CONTINUE
C*****************************************************

      FSCALE = 9.6E4
      MINH = 0.002
      MAXH = 0.5
      MAXIT(1) = 100
      MAXIT(2) = 10000
      RESTART = 1
      WRIT = 4
      TERMTOL = 1.0D0
      MAXCUTS = 3
      OPTION(1) = 1
      OPTION(2) = 2
      OPTION(3) = 0
      OPTION(4) = 1     
      DO 30 , I=5,20
      OPTION(I) = 0
 30   CONTINUE
      OPTION(7) = 1
C**************************************************
C Set the initial iterate:

C Well locations, in (x,y) pairs, IE. V(1) = x location of well 1, 
C V(2) = y location of well 1, V(3) = x-location of well 2, etc


      V(1) = 150
      V(2) = 750

      V(3) = 400
      V(4) = 750
      V(5) = 250
      V(6) = 650

      V(7) = 250
      V(8) = 450

C Initial well rates, ordered 1-4          
  
      V(9) = 0.0064
      V(10) = 0.0064
      V(11) = -0.0064
      V(12) = -0.0064




C*************************************************

C Call the IFFCO
      CALL COMMINITIF()
      CALL IFFCO(FEVAL,V,U,L,FSCALE,MINH,MAXH,DIM,MAXIT,
     +      RESTART,WRIT,TERMTOL,FMIN,MAXCUTS,OPTION)

C To evaluate the objective function at the intial iterate
C comment out the call to IFFCO and uncomment the call 
C to feval. This is useful when determining what to 
C set FSCALE to or to get a Matlab file for the initial
C well locations

C       CALL FEVAL(DIM,V,FV,FLAG)


C The following calls produce a matlab file with the
C head contours for the solution at the optmial point found by IFFCO.
C Commenting this out does not effect the optmization   
     
     
      CALL POSTPROC(DIM,V,FV,FLAG,NROW,NCOL,NLAY,HEAD)
    

      CALL COMMEXITIF()
      END







