
include(ExternalProject)
if(NOT SUNDIALS_EXTERNAL_SOURCE)
	set(SUNDIALS_EXTERNAL_SOURCE ${CMAKE_CURRENT_SOURCE_DIR}/external/sundials-5.4.0.tar.gz)
endif()

set(SUNDIALS_INSTALL_DIR ${CMAKE_INSTALL_PREFIX}/muq_external)


if( MUQ_USE_MPI )
ExternalProject_Add(
	SUNDIALS
                PREFIX ${CMAKE_CURRENT_BINARY_DIR}/external/sundials
                URL ${SUNDIALS_EXTERNAL_SOURCE}
                CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${SUNDIALS_INSTALL_DIR} -DCMAKE_INSTALL_LIBDIR=lib -DCMAKE_C_COMPILER=${CMAKE_C_COMPILER} -DCMAKE_CXX_COMPILER=${CMAKE_CXX_COMPILER} -DMPI_ENABLE=ON -DBUILD_CVODE=OFF -DBUILD_CVODES=ON -DBUILD_IDA=OFF -DBUILD_IDAS=ON -DBUILD_KINSOL=ON -DBUILD_SHARED_LIBS=ON -DBUILD_STATIC_LIBS=ON
                INSTALL_COMMAND make install
)
else()
ExternalProject_Add(
	SUNDIALS
                PREFIX ${CMAKE_CURRENT_BINARY_DIR}/external/sundials
                URL ${SUNDIALS_EXTERNAL_SOURCE}
                CMAKE_ARGS -DCMAKE_INSTALL_PREFIX=${SUNDIALS_INSTALL_DIR} -DCMAKE_INSTALL_LIBDIR=lib -DBUILD_CVODE=OFF -DBUILD_CVODES=ON -DBUILD_IDA=OFF -DBUILD_IDAS=ON -DBUILD_KINSOL=ON -DBUILD_SHARED_LIBS=ON -DBUILD_STATIC_LIBS=ON
                INSTALL_COMMAND make install
)
endif()


set_property( TARGET SUNDIALS PROPERTY FOLDER "Externals")

set(SUNDIALS_INCLUDE_DIRS ${SUNDIALS_INSTALL_DIR}/include )
set(SUNDIALS_INCLUDE_DIR ${SUNDIALS_INCLUDE_DIRS})

if( MUQ_USE_MPI )
	set(SUNDIALS_LIBRARIES ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_cvodes${CMAKE_SHARED_LIBRARY_SUFFIX}
                       ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_idas${CMAKE_SHARED_LIBRARY_SUFFIX}
		       ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_kinsol${CMAKE_SHARED_LIBRARY_SUFFIX}
		       ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_nvecserial${CMAKE_SHARED_LIBRARY_SUFFIX}
					 ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_nvecparallel${CMAKE_SHARED_LIBRARY_SUFFIX})
else()
	set(SUNDIALS_LIBRARIES ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_cvodes${CMAKE_SHARED_LIBRARY_SUFFIX}
                       ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_idas${CMAKE_SHARED_LIBRARY_SUFFIX}
		       ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_kinsol${CMAKE_SHARED_LIBRARY_SUFFIX}
		       ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_nvecserial${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

set(SUNDIALS_LIBRARY ${SUNDIALS_LIBRARIES})

if( MUQ_USE_MPI )
	set(SUNDIALS_LIBRARIES_STATIC ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_cvodes${CMAKE_STATIC_LIBRARY_SUFFIX}
                              ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_idas${CMAKE_STATIC_LIBRARY_SUFFIX}
			      ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_kinsol${CMAKE_STATIC_LIBRARY_SUFFIX}
			      ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_nvecserial${CMAKE_STATIC_LIBRARY_SUFFIX}
						${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_nvecparallel${CMAKE_STATIC_LIBRARY_SUFFIX})
else()
	set(SUNDIALS_LIBRARIES_STATIC ${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_cvodes${CMAKE_STATIC_LIBRARY_SUFFIX}
														${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_idas${CMAKE_STATIC_LIBRARY_SUFFIX}
					${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_kinsol${CMAKE_STATIC_LIBRARY_SUFFIX}
					${SUNDIALS_INSTALL_DIR}/lib/${CMAKE_SHARED_LIBRARY_PREFIX}sundials_nvecserial${CMAKE_STATIC_LIBRARY_SUFFIX})
endif()

set(MUQ_HAS_SUNDIALS 1)
